unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Variants, Controls, Forms,
  StdCtrls, Buttons, ImgList, Menus, ExtCtrls;

type
  TConfigForm = class(TForm)
    ImageList1: TImageList;
    Timer1: TTimer;
    PopupMenu: TPopupMenu;
    MenuAbout: TMenuItem;
    MenuConfig: TMenuItem;
    MenuExit: TMenuItem;
    MenuMisc: TMenuItem;
    MenuOpenStartup: TMenuItem;
    MenuCreateStartup: TMenuItem;
    ListBox: TListBox;
    Panel2: TPanel;
    BtnAdd: TBitBtn;
    BtnMod: TBitBtn;
    BtnDel: TBitBtn;
    BtnClose: TBitBtn;
    BtnUp: TBitBtn;
    BtnDown: TBitBtn;
    Bevel1: TBevel;
    Bevel2: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuConfigClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure MenuOpenStartupClick(Sender: TObject);
    procedure MenuCreateStartupClick(Sender: TObject);
    procedure BtnAddClick(Sender: TObject);
    procedure ListBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure BtnDelClick(Sender: TObject);
    procedure BtnUpClick(Sender: TObject);
    procedure BtnDownClick(Sender: TObject);
    procedure BtnCloseClick(Sender: TObject);
    procedure BtnModClick(Sender: TObject);
  private
    procedure   ShowPopupMenu(Sender: TObject);
    procedure   ShowConfig(Sender: TObject);
    function ValidItemIndex(var Index: integer): Boolean;
  public

  end;

var
  ConfigForm: TConfigForm;

implementation

{$R *.DFM}

uses
    Detail, iTray, Info, iMisc, iReminder, Types;

//  ---------------------------------------------------------------------------
//  j[N
procedure   TConfigForm.ShowPopupMenu(Sender: TObject);
begin
    SetForegroundWindow(Handle);
    PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

//  ---------------------------------------------------------------------------
//  j[N
procedure   TConfigForm.ShowConfig(Sender: TObject);
begin
    SetForegroundWindow(Handle);                  
    MenuConfig.OnClick(MenuConfig);
end;

//  ---------------------------------------------------------------------------
//  tH[
procedure TConfigForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title + ' - ' + Self.Name;

    Application.ShowMainForm := false;
    ShowWindow(Application.Handle, SW_HIDE);

    SimpleTray := TSimpleTaskTray.Create(Application.Icon.Handle);
    SimpleTray.FOnLeftDblClick := ShowConfig;
    SimpleTray.FOnRightClick := ShowPopupMenu;
    SimpleTray.AddTray(ExtractFileName(ParamStr(0)));
    ConfigList.LoadFromFile(ChangeFileExt(ParamStr(0), '.dat'));
    ListBox.Count := ConfigList.Count;

    Timer1.Enabled := true;
end;

//  ---------------------------------------------------------------------------
//  tH[j
procedure TConfigForm.FormDestroy(Sender: TObject);
begin
    Timer1.Enabled := false;

    ConfigList.SaveToFile(ChangeFileExt(ParamStr(0), '.dat'));
    SimpleTray.Free();
end;

//  ---------------------------------------------------------------------------
//  s
procedure TConfigForm.Timer1Timer(Sender: TObject);
var
    Config: TReminderConfig;
    i: integer;
    Temp: TIcon;
    Icon: HICON;
begin
    Config := nil;
    if ConfigList.DoRemind(Config) then
    begin
        Temp := TIcon.Create;
        for i := 0 to ImageList1.Count - 1 do
        begin
            ImageList1.GetIcon(i, Temp);
            Icon := Temp.Handle;
            SimpleTray.ModTray(Icon);
            Sleep(100);
        end;
        Temp.Free;
        SimpleTray.ModTray(Application.Icon.Handle);
        Config.Execute();
    end;
end;

//  ---------------------------------------------------------------------------
procedure TConfigForm.MenuExitClick(Sender: TObject);
begin
    Self.Close();
end;

//  ---------------------------------------------------------------------------
procedure TConfigForm.MenuConfigClick(Sender: TObject);
begin
    Self.Show();
end;

//  ---------------------------------------------------------------------------
procedure TConfigForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//  ---------------------------------------------------------------------------
//  I
procedure TConfigForm.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
//    CanClose := SimpleOkCancel('Are you SURE want to QUIT ?');
//    if not CanClose then Self.Hide();
end;

//  ---------------------------------------------------------------------------
//  X^[gAbvJ
procedure TConfigForm.MenuOpenStartupClick(Sender: TObject);
begin
    SimpleExecute(GetStartUpFolderPath());
end;

//  ---------------------------------------------------------------------------
//  X^[gAbvɓo^
procedure TConfigForm.MenuCreateStartupClick(Sender: TObject);
begin
    CreateStartup();
end;

//  ---------------------------------------------------------------------------
//  `
procedure TConfigForm.ListBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
    Config: TReminderConfig;
    ItemText: string;
    OffsetX, OffsetY: integer;
begin
    Config := ConfigList.Item(Index);
    ItemText := Config.ToString();

    OffsetX := 5;
    OffsetY := (Rect.Bottom - Rect.Top - ListBox.Canvas.TextHeight(ItemText)) div 2;

    Inc(OffsetX, Rect.Left);
    Inc(OffsetY, Rect.Top);

    ListBox.Canvas.TextRect(Rect, OffsetX, OffsetY, ItemText);
end;

//  ---------------------------------------------------------------------------
//  ƑIĂ邩?
function TConfigForm.ValidItemIndex(var Index: integer): Boolean;
begin
    Index := ListBox.ItemIndex;
    Result := (Index <> -1);
end;

//  ---------------------------------------------------------------------------
//  폜
procedure TConfigForm.BtnDelClick(Sender: TObject);
var
    Index: integer;
begin
    Timer1.Enabled := false;
    if ValidItemIndex(Index) then
    begin
        //  폜
        ConfigList.Delete(ListBox.ItemIndex);
        //  ύX
        ListBox.Count := ConfigList.Count;
        //  Iʒu𒲐
        if (ListBox.Count > 0) then
        begin
            Dec(Index);
            if (Index < 0) then Index := 0;
            ListBox.ItemIndex := Index;
        end;
    end;
    Timer1.Enabled := true;
end;

//  ---------------------------------------------------------------------------
//  Ɉړ
procedure TConfigForm.BtnUpClick(Sender: TObject);
var
    Index, NewIndex: integer;
begin
    Timer1.Enabled := false;
    if ValidItemIndex(Index) then
    begin
        if (Index > 0) then
        begin
            NewIndex := Index - 1;
            ConfigList.Move(Index, NewIndex);
            ListBox.ItemIndex := NewIndex;
        end;
    end;
    Timer1.Enabled := true;
end;

//  ---------------------------------------------------------------------------
//  Ɉړ
procedure TConfigForm.BtnDownClick(Sender: TObject);
var
    Index, NewIndex: integer;
begin
    Timer1.Enabled := false;
    if ValidItemIndex(Index) then
    begin
        if (Index < ListBox.Count - 1) then
        begin
            NewIndex := Index + 1;
            ConfigList.Move(Index, NewIndex);
            ListBox.ItemIndex := NewIndex;
        end;
    end;
    Timer1.Enabled := true;
end;

//  ---------------------------------------------------------------------------
//  
procedure TConfigForm.BtnCloseClick(Sender: TObject);
begin
    Self.Hide();
end;

//  ---------------------------------------------------------------------------
//  ǉ
procedure TConfigForm.BtnAddClick(Sender: TObject);
begin
    Timer1.Enabled := false;
    if OpenDetail(Self, nil) then
    begin
        ListBox.Count := ConfigList.Count;
    end;
    Timer1.Enabled := true;
end;

//  ---------------------------------------------------------------------------
//  ύX
procedure TConfigForm.BtnModClick(Sender: TObject);
var
    Index: integer;
    Config: TReminderConfig;
begin
    Timer1.Enabled := false;
    if ValidItemIndex(Index) then
    begin
        Config := ConfigList.Item(Index);
        if OpenDetail(Self, Config) then
        begin
            ListBox.Refresh();
        end;
    end;
    Timer1.Enabled := true;
end;

end.

